-------------------------------------------------------------------------------
--
--  Title      : 나를 불러주세요~ (and/or/not 검색추가판 by prodol)
--  Version    : 1.6
--  Author     : Blink
--  Date       : 2005/03/26
--  LastUpdate : 2006/10/14
--
--  Special Thanks : Deblan,Damjau
--
-------------------------------------------------------------------------------
local Use_BlinkCallme = true    -- '나를 불러 주세요' 사용여부
local Use_BlinkWhoSaid = true   -- '누가말하나' 사용여부
local Use_BlinkXChannel = true  -- '난빼줘' 사용여부

-------------------------------------------------------------------------------
-- and/or/not/unable parsing 구문 추가 : &(and) ,(or) ~(not) !(unable)
-------------------------------------------------------------------------------
local BCM_not_delimiter = '~'
local BCM_or_delimiter = ','
local BCM_and_delimiter = '&'
local BCM_unable_delimiter = '!'
local playerName = ""

local BCM_patterns = {}

BCMPattern = {}
BCMPattern.__index = BCMPattern

function BCMPattern:new(str)
	local p = {}
	setmetatable(p, BCMPattern)

	p.array = {}
	p:build(str)
	return p
end

function BCMPattern:build(str) -- was and_token
	local _, _, found = string.find(str, "^%s*("..BCM_unable_delimiter.."?).*$")

	if found and found ~= "" then -- 문장 앞에 !가 있으면 작동시키지 않는다.
		self.unable = true
		return
	end

	local cnt = 1
	local n, token, _str
	local array = self.array

	while 1 do
		_str = str
		n, _, token, str = string.find(str, "(.-)"..BCM_and_delimiter.."(.*)")

		if not n then -- last token
			_str = string.gsub(_str, "^%s*(.-)%s*$", "%1") -- trim space
			if _str and _str ~= "" then
				array[cnt] = {}
				self:or_token(array[cnt], _str)
				cnt = cnt + 1
			end
			break
		end

		token = string.gsub(token, "^%s*(.-)%s*$", "%1") -- trim space

		if token and token ~= "" then
			array[cnt] = {}
			self:or_token(array[cnt], token)
			cnt = cnt + 1
		end
	end
end

function BCMPattern:not_token(array, str)
	local _, _, found, token = string.find(str, "^("..BCM_not_delimiter.."?)%s*(.*)$")

	if found and found ~= "" then
		table.insert(array, true)
	else
		table.insert(array, false)
	end

	table.insert(array, token)
end

function BCMPattern:or_token(array, str)
	local cnt = 1
	local n, token, _str

	while 1 do
		_str = str
		n, _, token, str = string.find(str, "(.-)"..BCM_or_delimiter.."(.*)")

		if not n then -- last token
			_str = string.gsub(_str, "^%s*(.-)%s*$", "%1") -- trim space
			if _str and _str ~= "" then
				array[cnt] = {}
				self:not_token(array[cnt], _str)
				cnt = cnt + 1
			end
			break
		end

		token = string.gsub(token, "^%s*(.-)%s*$", "%1") -- trim space

		if token and token ~= "" then
			array[cnt] = {}
			self:not_token(array[cnt], token)
			cnt = cnt + 1
		end
	end
end

function BCMPattern:find(str)
	if self.unable then
		return false
	end

	local found = true
	local array = self.array
	local or_found
	local i, j

	for i = 1, #array do
		or_found = false

		if array[i] then
			for j = 1, #array[i] do
				if array[i][j][1] then -- ~ found
					if not string.find(str, array[i][j][2]) then -- or 패턴 중 한개라도 찾으면 바로 나감.
						or_found = true
						break
					end
				else
					if string.find(str, array[i][j][2]) then -- or 패턴 중 한개라도 찾으면 바로 나감.
						or_found = true
						break
					end
				end
			end
		end

		if not or_found then -- or 중에서 하나도 못찾음. 종료함.
			found = false
			break
		end
	end

	return found
end

-------------------------------------------------------------------------------
-- BlinkPrint
-------------------------------------------------------------------------------
if (not BlinkPrint) then
	BlinkPrint = function(msg)
		if (ChatFrame1) then
			ChatFrame1:AddMessage(msg, 1.0, 1.0, 0.0)
		end
	end
end

function BlinkCallMe_OnLoad()
	if Use_BlinkCallme or Use_BlinkWhoSaid or Use_BlinkXChannel then
		this:RegisterEvent("CHAT_MSG_CHANNEL")
		this:RegisterEvent("CHAT_MSG_SAY")
		this:RegisterEvent("CHAT_MSG_PARTY")
		this:RegisterEvent("CHAT_MSG_YELL")
		this:RegisterEvent("CHAT_MSG_WHISPER")
		this:RegisterEvent("CHAT_MSG_RAID")
		this:RegisterEvent("CHAT_MSG_RAID_WARNING")
		this:RegisterEvent("CHAT_MSG_RAID_LEADER")
		this:RegisterEvent("CHAT_MSG_GUILD")
		this:RegisterEvent("CHAT_MSG_MONSTER_SAY")
		this:RegisterEvent("CHAT_MSG_MONSTER_YELL")
		this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
		this:RegisterEvent("VARIABLES_LOADED")

		BlinkCallMeNames = {}
		BlinkWhoSaidNames = {}
		BlinkXChannelNames = {}
	end

	-- Slash commands
	if Use_BlinkCallme then
		SlashCmdList["BCALLME"] = function (msg) BlinkCallMe_SlashCmd(msg) end
		SLASH_BCALLME1 = "/나를불러주세요"
		SLASH_BCALLME2 = "/callme"
	end

	if Use_BlinkWhoSaid then
		SlashCmdList["BWHOSAID"] = function (msg) BlinkCallMe_WhoSaidSlashCmd(msg) end
		SLASH_BWHOSAID1 = "/누가말하나"
		SLASH_BWHOSAID2 = "/whosaid"
	end

	if Use_BlinkXChannel then
		SlashCmdList["BXCHANNEL"] = function (msg) BlinkCallMe_XChannelSlashCmd(msg) end
		SLASH_BXCHANNEL1 = "/난빼줘"
		SLASH_BXCHANNEL2 = "/xchannel"
	end

	BCM_BlinkModRegister()

	playerName = string.lower(UnitName("player"))
end

function BlinkCallMe_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		BlinkCallMe_BuildPatterns()
		return
	end

	local showCallme = false
	local showWhosaid = false

	if Use_BlinkXChannel then
		if (event == "CHAT_MSG_CHANNEL") then
			for k,v in pairs(BlinkXChannelNames) do
				if (type(v) == "number" and v == arg8) then
					return
				elseif (type(v) == "string" and v == arg9) then
					return
				end
			end
		end
	end

	local text = string.lower(arg1)
	local who = string.lower(arg2)

	if Use_BlinkCallme then
		if (string.find(text, playerName)) then
			showCallme = true
		else
			for i=1, #BCM_patterns do
				if BCM_patterns[i]:find(text) then
					showCallme = true
					break
				end
			end
		end
	end

	if Use_BlinkWhoSaid then
		for i=1, #BlinkWhoSaidNames do
			if (event ~= "CHAT_MSG_RAID_WARNING" and who == BlinkWhoSaidNames[i]) then
				showWhosaid = true
			end
		end
	end

	if ((showCallme == true or showWhosaid == true) and who ~= playerName) then
	--if ((showCallme == true or showWhosaid == true)) then
		local chattypes = getglobal("ChatTypeInfo")

		if (event == "CHAT_MSG_MONSTER_EMOTE") then
			arg1 = string.format(arg1, arg2)
		end

		local color = chattypes[string.sub(event, 10, -1)]

		if not color then
			color = { r=0.7, g=0.7, b=0.7 }
		end

		if (showCallme == true and showWhosaid == true) then
			-- BlinkBanner함수는 작은 글자로 표시해줍니다.
			-- BlinkBanner(arg2..": "..arg1, color)
			--RaidWarningFrame:AddMessage(arg2..": "..arg1, color.r, color.g, color.b, 1.0)
			RaidNotice_AddMessage( RaidWarningFrame, arg2..": "..arg1, ChatTypeInfo["RAID_WARNING"] );

			-- 경매장 종료할때 나오는 '땡땡'소리입니다.
			-- PlaySound("AuctionWindowClose") -- 이것을 원한다면 주석을 해제해주십시오.
			PlaySound("RaidWarning")

			-- 외부사운드파일 불러들여서 소리를 냅니다. (자신이 원하는 wav파일을 불러올수도 있습니다. 하지만 크면 리소스에 영향을 줄수 있습니다)
			-- PlaySoundFile("Interface\\AddOns\\BlinkCallMe\\BlinkCallMe.wav") -- 클라이언트 v1.11에서 외부사운드 플레이 버그로인해 주석처리
		elseif (showCallme == true and showWhosaid == false) then
			-- BlinkBanner함수는 작은 글자로 표시해줍니다.
			BlinkBanner(arg2..": "..arg1, color)

			-- ChatFrame3:AddMessage(arg2..": "..arg1, color.r, color.g, color.b)
			-- 큰글자로 보여주길 원한다면 이 주석을 해제합니다.
			-- RaidWarningFrame:AddMessage(arg2..": "..arg1, color.r, color.g, color.b, 1.0)

			-- 경매장 종료할때 나오는 '땡땡'소리입니다.
			-- PlaySound("AuctionWindowClose") -- 이것을 원한다면 주석을 해제해주십시오.
			-- PlaySound("AuctionWindowOpen")

			-- 외부사운드파일 불러들여서 소리를 냅니다. (자신이 원하는 wav파일을 불러올수도 있습니다. 하지만 크면 리소스에 영향을 줄수 있습니다)
			PlaySound("GLUESCREENSMALLBUTTONMOUSEDOWN") -- 2.2 버그로 인한 불필요한 코드임. 패치 후 삭제 -Isidur
			PlaySoundFile("Interface\\AddOns\\BlinkCallMe\\BlinkCallMe.wav")
		elseif (showCallme == false and showWhosaid == true) then
			-- BlinkBanner함수는 작은 글자로 표시해줍니다.
			-- BlinkBanner(arg2..": "..arg1, color)

			--RaidWarningFrame:AddMessage(arg2..": "..arg1, color.r, color.g, color.b, 1.0)
			RaidNotice_AddMessage( RaidWarningFrame, arg2..": "..arg1, ChatTypeInfo["RAID_WARNING"] );

			-- 경매장 종료할때 나오는 '땡땡'소리입니다.
			--      PlaySound("AuctionWindowClose") -- 이것을 원한다면 주석을 해제해주십시오.
			PlaySound("RaidWarning")

			-- 외부사운드파일 불러들여서 소리를 냅니다. (자신이 원하는 wav파일을 불러올수도 있습니다. 하지만 크면 리소스에 영향을 줄수 있습니다)
			-- PlaySoundFile("Interface\\AddOns\\BlinkCallMe\\BlinkCallMe.wav")
		end
	end
end

-- CallMe
function BlinkCallMe_AddText(text)
	local exist = false
	if not text then return end
	if text == "" then return end

	for i=1,#BlinkCallMeNames,1 do
		if (BlinkCallMeNames[i] == text) then
			exist = true
		end
	end

	if (exist == false) then
		table.insert(BlinkCallMeNames, text)
	end

	BlinkCallMe_BuildPatterns()
end

function BlinkCallMe_RemoveText(t)
	local _type = "string"
	local rn = 0

	if (type(t) == "number") then
		_type = "number"
		rn = t
	end

	if (type(t) == "string") then
		local n = tonumber(t)
		if n and n <= #BlinkCallMeNames then
			_type = "number"
			rn = n
		end
	end

	if (_type == "string") then
		for i=1, #BlinkCallMeNames, 1 do
			if (BlinkCallMeNames[i] == t) then
				rn = i
			end
		end
	end

	table.remove(BlinkCallMeNames, rn)

	BlinkCallMe_BuildPatterns()
end

function BlinkCallMe_BuildPatterns()
	BCM_patterns = {}

	for i=1, #BlinkCallMeNames do
		BCM_patterns[i] = BCMPattern:new(BlinkCallMeNames[i])
	end
end

function BlinkCallMeList()
	BlinkPrint("-----------------")

	if (#BlinkCallMeNames > 0) then
		for i=1, #BlinkCallMeNames do
			BlinkPrint(i..". "..BlinkCallMeNames[i])
		end
	else
		BlinkPrint("    없습니다^^")
	end

	BlinkPrint("-----------------")
end

-- WhoSaid
function BlinkWhoSaid_AddText(text)
	local exist = false
	if not text then return end
	if text == "" then return end
	for i=1,#BlinkWhoSaidNames,1 do
		if (BlinkWhoSaidNames[i] == text) then
			exist = true
		end
	end
	if (exist == false) then
		table.insert(BlinkWhoSaidNames,text)
	end
end

function BlinkWhoSaid_RemoveText(t)
	local _type = "string"
	local rn = 0

	if (type(t) == "number") then
		_type = "number"
		rn = t
	end

	if (type(t) == "string") then
		local n = tonumber(t)
		if n and n <= #BlinkWhoSaidNames then
			_type = "number"
			rn = n
		end
	end

	if (_type == "string") then
		for i=1,#BlinkWhoSaidNames,1 do
			if (BlinkWhoSaidNames[i] == t) then
				rn = i
			end
		end
	end

	table.remove(BlinkWhoSaidNames, rn)
end

function BlinkWhoSaidList()
	BlinkPrint("-----------------")
	if (#BlinkWhoSaidNames > 0) then
		for i=1,#BlinkWhoSaidNames do
			BlinkPrint(i..". "..BlinkWhoSaidNames[i])
		end
	else
		BlinkPrint("    없습니다^^")
	end
	BlinkPrint("-----------------")
end

-- XChannel
function BlinkXChannel_AddText(text)
	if not text then return end
	if text=="" then return end
	if (string.find(text, "^%d+$")) then
		x = tonumber(text)
	else
		x = text
	end
	for k,v in pairs(BlinkXChannelNames) do
		if (v == x) then
			return
		end
	end
	table.insert(BlinkXChannelNames, x)
end

function BlinkXChannel_RemoveText(t)
	local i = nil
	for k,v in pairs(BlinkXChannelNames) do
		if( tostring(v) == t) then
			i = index
		end
	end
	if( i) then
		table.remove(BlinkXChannelNames,i)
	end
end

function BlinkXChannel_RemoveByIndex(i)
	if( i >= 1 and i <= #BlinkXChannelNames) then
		table.remove(BlinkXChannelNames,i)
	end
end

function BlinkXChannelList()
	BlinkPrint("-----------------")
	if( #BlinkXChannelNames > 0) then
		for k,v in pairs(BlinkXChannelNames) do
			if( type(v) == "string") then
				BlinkPrint(k..". "..v)
			else
				local _, channel = GetChannelName(v)
				BlinkPrint(k..". "..v.." ("..(channel or "없음")..")")
			end
		end
	else
		BlinkPrint("    없습니다^^")
	end
	BlinkPrint("-----------------")
end

-- display text
function BlinkBanner(msg, color)
	if (UIErrorsFrame) then
		if (not color) then
			color = { r = 1.0, g = 0.2, b = 0.2 }
		end

		UIErrorsFrame:AddMessage(msg, color.r, color.g, color.b, 1.0, UIERRORS_HOLD_TIME)
	end
end

-- slash commands
function BlinkCallMe_SlashCmd(msg)
	local cmd = gsub(msg, "%s*([^%s]+).*", "%1")
	local name = gsub(msg, "%s*([^%s]+)%s*(.*)", "%2")

	if( strlen(cmd) <= 0) then
		BlinkCallMe_Usage()
		return
	end

	if( cmd == "추가" or cmd == "add")then
		if( not name or name == "") then
			BlinkCallMe_Usage()
			return
		end

		BlinkCallMe_AddText(name)
		BlinkCallMeList()
		return
	elseif (cmd == "제거" or cmd == "삭제" or cmd == "del" or cmd == "remove") then
		if (not name or name == "") then
			BlinkCallMe_Usage()
			return
		end
		BlinkCallMe_RemoveText(name)
		BlinkCallMeList()
		return
	elseif( cmd == "보기" or cmd == "목록" or cmd == "list" or cmd == "show") then
		BlinkCallMeList()
		return
	end
	BlinkCallMe_Usage()
end

function BlinkCallMe_Usage()
	BlinkPrint("나를 불러주세요~ 사용방법:")
	BlinkPrint(" /나를불러주세요          : 도움말")
	BlinkPrint(" /나를불러주세요 추가 추가할이름   : 이름을 추가합니다.")
	BlinkPrint(" /나를불러주세요 제거 이름(또는 번호) : 등록되어있는 이름을 제거합니다.")
	BlinkPrint(" /나를불러주세요 보기(또는 목록) : 등록되어있는 이름을 확인합니다.")
end

function BlinkCallMe_WhoSaidSlashCmd(msg)
	local cmd = gsub(msg, "%s*([^%s]+).*", "%1")
	local name = gsub(msg, "%s*([^%s]+)%s*(.*)", "%2")

	if (strlen(cmd) <= 0) then
		BlinkWhoSaid_Usage()
		return
	end

	if (cmd == "추가" or cmd == "add") then
		if (not name or name == "") then
			BlinkWhoSaid_Usage()
			return
		end
		BlinkWhoSaid_AddText(name)
		BlinkWhoSaidList()
		return
	elseif (cmd == "제거" or cmd == "삭제" or cmd == "del" or cmd == "remove") then
		if (not name or name == "") then
			BlinkWhoSaid_Usage()
			return
		end
		BlinkWhoSaid_RemoveText(name)
		BlinkWhoSaidList()
		return
	elseif( cmd == "보기" or cmd == "목록" or cmd == "list" or cmd == "show") then
		BlinkWhoSaidList()
		return
	end
	BlinkWhoSaid_Usage()
end

function BlinkWhoSaid_Usage()
	BlinkPrint("누가말하나~ 사용방법:")
	BlinkPrint(" /누가말하나          : 도움말")
	BlinkPrint(" /누가말하나 추가 추가할이름   : 이름을 추가합니다.")
	BlinkPrint(" /누가말하나 제거 이름(또는 번호) : 등록되어있는 이름을 제거합니다.")
	BlinkPrint(" /누가말하나 보기(또는 목록) : 등록되어있는 이름을 확인합니다.")
end

function BlinkCallMe_XChannelSlashCmd(msg)
	local cmd = gsub(msg, "%s*([^%s]+).*", "%1")
	local name = gsub(msg, "%s*([^%s]+)%s*(.*)", "%2")

	if( strlen(cmd) <= 0) then
		BlinkXChannel_Usage()
		return
	end

	if( cmd == "추가" or cmd == "add")then
		if( not name or name == "") then
			BlinkXChannel_Usage()
			return
		end
		BlinkXChannel_AddText(name)
		BlinkXChannelList()
		return
	elseif( cmd == "제거" or cmd == "삭제" or cmd == "del" or cmd == "remove") then
		if( not name or name == "") then
			BlinkXChannel_Usage()
			return
		end
		BlinkXChannel_RemoveText(name)
		BlinkXChannelList()
		return
	elseif( cmd == "보기" or cmd == "목록" or cmd == "list" or cmd == "show") then
		BlinkXChannelList()
		return
	end
	BlinkXChannel_Usage()
end

function BlinkXChannel_Usage()
	BlinkPrint("난빼줘~ 사용방법:")
	BlinkPrint(" (지정한 채널은 나를불러주세요 또는 누가말하나?에서 제외됩니다.)")
	BlinkPrint(" /난빼줘          : 도움말")
	BlinkPrint(" /난빼줘 추가 이름(또는 번호) : 채널을 추가합니다.")
	BlinkPrint(" /난빼줘 제거 이름(또는 번호) : 등록되어있는 채널을 제거합니다.")
	BlinkPrint(" /난빼줘 보기(또는 목록) : 등록되어있는 채널을 확인합니다.")
end

function BCM_BlinkModRegister()
	if (not BlinkMod_RegisterMenu) then
		return
	end

	local info

	if Use_BlinkCallme then
		-- tier 1
		info = {}
		info.parentkey = "SELF"
		info.key = "BCMMAIN"
		info.text = "나를불러주세요"
		info.hasArrow = 1
		info.tooltipTitle = "나를불러주세요"
		info.tooltipText = "채팅창에서 지정한 문구를 발견하면 사용자에게 표시해줍니다."
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 1 )

		-- tier 2 : parent = BCMMAIN
		info = {}
		info.parentkey = "BCMMAIN"
		info.key = "BCMTITLE"
		info.text = "나를불러주세요"
		info.isTitle = 1
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 2 )

		info = {}
		info.parentkey = "BCMMAIN"
		info.key = "BCMADDCALLME"
		info.text = "추가하기"
		info.tooltipTitle = "추가하기"
		info.tooltipText = "강조할 문구를 추가합니다."
		info.ClickFunction = BCM_BM_AddCallMeClick
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 2 )

		info = {}
		info.parentkey = "BCMMAIN"
		info.key = "BCMLIST"
		info.hasArrow = 1
		info.text = "목록 편집 및 제거하기"
		info.tooltipTitle = "목록 편집 및 제거하기"
		info.tooltipText = "등록된 문구를 확인하고 편집 및 삭제할 수 있습니다."
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 2 )

		-- tier 3 : parent = BCMLIST
		for i=1,15,1 do
			info = {}
			info.parentkey = "BCMLIST"
			info.key = "BCMLIST"..i
			info.text = i..". 문구"
			info.tooltipTitle = "세트1"
			info.tooltipText = "목록에서 제거하시려면 클릭하세요."
			info.ClickFunction = getglobal("BCM_BM_Remove"..i.."Click")
			info.GetNameFunction = getglobal("BCM_BM_Remove"..i.."Name")
			info.ShowHideFunction = getglobal("BCM_BM_Remove"..i.."Show")
			info.notCheckable = 1
			BlinkMod_RegisterMenu( info, 3 )
		end
	end

	if Use_BlinkWhoSaid then
		-- tier 1
		info = {}
		info.parentkey = "SELF"
		info.key = "BWSMAIN"
		info.text = "누가말하나?"
		info.hasArrow = 1
		info.tooltipTitle = "누가말하나?"
		info.tooltipText = "채팅창에서 지정한 플레이어가 말하면 사용자에게 표시해줍니다."
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 1 )

		-- tier 2 : parent = BWSMAIN
		info = {}
		info.parentkey = "BWSMAIN"
		info.key = "BWSTITLE"
		info.text = "누가말하나?"
		info.isTitle = 1
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 2 )

		info = {}
		info.parentkey = "BWSMAIN"
		info.key = "BWSADDWHOSAID"
		info.text = "추가하기"
		info.tooltipTitle = "추가하기"
		info.tooltipText = "강조할 플레이어를 추가합니다."
		info.ClickFunction = BCM_BM_AddWhoSaidClick
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 2 )

		info = {}
		info.parentkey = "BWSMAIN"
		info.key = "BWSLIST"
		info.hasArrow = 1
		info.text = "목록 및 제거하기"
		info.tooltipTitle = "목록 및 제거하기"
		info.tooltipText = "등록된 플레이어를 확인하고 삭제할수있습니다."
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 2 )

		-- tier 3 : parent = BCMLIST
		for i=1,15,1 do
			info = {}
			info.parentkey = "BWSLIST"
			info.key = "BWSLIST"..i
			info.text = i..". 문구"
			info.tooltipTitle = "세트1"
			info.tooltipText = "목록에서 제거하시려면 클릭하세요."
			info.ClickFunction = getglobal("BCM_BM_TWRemove"..i.."Click")
			info.GetNameFunction = getglobal("BCM_BM_TWRemove"..i.."Name")
			info.ShowHideFunction = getglobal("BCM_BM_TWRemove"..i.."Show")
			info.notCheckable = 1
			BlinkMod_RegisterMenu( info, 3 )
		end
	end

	if Use_BlinkXChannel then
		-- tier 1
		info = {}
		info.parentkey = "SELF"
		info.key = "BXCMAIN"
		info.text = "난빼줘"
		info.hasArrow = 1
		info.tooltipTitle = "난빼줘"
		info.tooltipText = "지정한 채널은 나를불러주세요 또는 누가말하나?에서 제외됩니다."
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 1 )

		-- tier 2 : parent = BWSMAIN
		info = {}
		info.parentkey = "BXCMAIN"
		info.key = "BXCTITLE"
		info.text = "난빼줘"
		info.isTitle = 1
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 2 )

		info = {}
		info.parentkey = "BXCMAIN"
		info.key = "BXCADDXCHANNEL"
		info.text = "추가하기"
		info.tooltipTitle = "추가하기"
		info.tooltipText = "제외할 채널을 추가합니다."
		info.ClickFunction = BCM_BM_AddXChannelClick
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 2 )

		info = {}
		info.parentkey = "BXCMAIN"
		info.key = "BXCLIST"
		info.hasArrow = 1
		info.text = "목록 및 제거하기"
		info.tooltipTitle = "목록 및 제거하기"
		info.tooltipText = "등록된 채널을 확인하고 삭제할수있습니다."
		info.notCheckable = 1
		BlinkMod_RegisterMenu( info, 2 )

		-- tier 3 : parent = BCMLIST
		for i=1,15,1 do
			info = {}
			info.parentkey = "BXCLIST"
			info.key = "BXCLIST"..i
			info.text = i..". 문구"
			info.tooltipTitle = "세트1"
			info.tooltipText = "목록에서 제거하시려면 클릭하세요."
			info.ClickFunction = getglobal("BCM_BM_XCRemove"..i.."Click")
			info.GetNameFunction = getglobal("BCM_BM_XCRemove"..i.."Name")
			info.ShowHideFunction = getglobal("BCM_BM_XCRemove"..i.."Show")
			info.notCheckable = 1
			BlinkMod_RegisterMenu( info, 3 )
		end
	end
end

-- CallMe
local BlinkCallMe_Edit_number
function BCM_BM_AddCallMeClick()
	StaticPopup_Show("ADD_CALLME")
end

function BCM_BM_RemoveClick(number)
	if (number) then
		number = 0 + number
		if IsShiftKeyDown() then
			BlinkCallMe_Edit_number = number
			StaticPopup_Show("EDIT_CALLME")
		else
			BlinkCallMe_RemoveText(number)
		end
	end
end

function BCM_BM_RemoveName(number)
	if (BlinkCallMeNames[number]) then
		return number..". "..BlinkCallMeNames[number]
	end
end

function BCM_BM_RemoveShow(number)
	if (BlinkCallMeNames[number]) then
		return true
	else
		return false
	end
end

function BCM_BM_Remove1Click() BCM_BM_RemoveClick(1) end
function BCM_BM_Remove1Name() return BCM_BM_RemoveName(1) end
function BCM_BM_Remove1Show() return BCM_BM_RemoveShow(1) end

function BCM_BM_Remove2Click() BCM_BM_RemoveClick(2) end
function BCM_BM_Remove2Name() return BCM_BM_RemoveName(2) end
function BCM_BM_Remove2Show() return BCM_BM_RemoveShow(2) end

function BCM_BM_Remove3Click() BCM_BM_RemoveClick(3) end
function BCM_BM_Remove3Name() return BCM_BM_RemoveName(3) end
function BCM_BM_Remove3Show() return BCM_BM_RemoveShow(3) end

function BCM_BM_Remove4Click() BCM_BM_RemoveClick(4) end
function BCM_BM_Remove4Name() return BCM_BM_RemoveName(4) end
function BCM_BM_Remove4Show() return BCM_BM_RemoveShow(4) end

function BCM_BM_Remove5Click() BCM_BM_RemoveClick(5) end
function BCM_BM_Remove5Name() return BCM_BM_RemoveName(5) end
function BCM_BM_Remove5Show() return BCM_BM_RemoveShow(5) end

function BCM_BM_Remove6Click() BCM_BM_RemoveClick(6) end
function BCM_BM_Remove6Name() return BCM_BM_RemoveName(6) end
function BCM_BM_Remove6Show() return BCM_BM_RemoveShow(6) end

function BCM_BM_Remove7Click() BCM_BM_RemoveClick(7) end
function BCM_BM_Remove7Name() return BCM_BM_RemoveName(7) end
function BCM_BM_Remove7Show() return BCM_BM_RemoveShow(7) end

function BCM_BM_Remove8Click() BCM_BM_RemoveClick(8) end
function BCM_BM_Remove8Name() return BCM_BM_RemoveName(8) end
function BCM_BM_Remove8Show() return BCM_BM_RemoveShow(8) end

function BCM_BM_Remove9Click() BCM_BM_RemoveClick(9) end
function BCM_BM_Remove9Name() return BCM_BM_RemoveName(9) end
function BCM_BM_Remove9Show() return BCM_BM_RemoveShow(9) end

function BCM_BM_Remove10Click() BCM_BM_RemoveClick(10) end
function BCM_BM_Remove10Name() return BCM_BM_RemoveName(10) end
function BCM_BM_Remove10Show() return BCM_BM_RemoveShow(10) end

function BCM_BM_Remove11Click() BCM_BM_RemoveClick(11) end
function BCM_BM_Remove11Name() return BCM_BM_RemoveName(11) end
function BCM_BM_Remove11Show() return BCM_BM_RemoveShow(11) end

function BCM_BM_Remove12Click() BCM_BM_RemoveClick(12) end
function BCM_BM_Remove12Name() return BCM_BM_RemoveName(12) end
function BCM_BM_Remove12Show() return BCM_BM_RemoveShow(12) end

function BCM_BM_Remove13Click() BCM_BM_RemoveClick(13) end
function BCM_BM_Remove13Name() return BCM_BM_RemoveName(13) end
function BCM_BM_Remove13Show() return BCM_BM_RemoveShow(13) end

function BCM_BM_Remove14Click() BCM_BM_RemoveClick(14) end
function BCM_BM_Remove14Name() return BCM_BM_RemoveName(14) end
function BCM_BM_Remove14Show() return BCM_BM_RemoveShow(14) end

function BCM_BM_Remove15Click() BCM_BM_RemoveClick(15) end
function BCM_BM_Remove15Name() return BCM_BM_RemoveName(15) end
function BCM_BM_Remove15Show() return BCM_BM_RemoveShow(15) end

StaticPopupDialogs["ADD_CALLME"] = {
	text = "채팅창에서 강조할 문구를 입력해주십시오.\n채팅창에 입력한 문구가 올라오면 '띵~'소리와 함께 화면중앙에 표시합니다.",
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	maxLetters = 240,
	OnAccept = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox")
		BlinkCallMe_AddText(editBox:GetText())
	end,
	OnShow = function()
		getglobal(this:GetName().."EditBox"):SetFocus()
	end,
	OnHide = function()
		if (ChatFrameEditBox:IsVisible()) then
			ChatFrameEditBox:SetFocus()
		end
		getglobal(this:GetName().."EditBox"):SetText("")
	end,
	EditBoxOnEnterPressed = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox")
		BlinkCallMe_AddText(editBox:GetText())
		this:GetParent():Hide()
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide()
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1
}

StaticPopupDialogs["EDIT_CALLME"] = {
	text = "입력한 문구를 편집할 수 있습니다.",
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	maxLetters = 240,
	OnAccept = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox")
		BlinkCallMeNames[BlinkCallMe_Edit_number] = editBox:GetText()

		BlinkCallMe_BuildPatterns()
	end,
	OnShow = function()
		local editBox = getglobal(this:GetName().."EditBox")
		editBox:SetFocus()
		editBox:SetText(BlinkCallMeNames[BlinkCallMe_Edit_number])
	end,
	OnHide = function()
		if (ChatFrameEditBox:IsVisible()) then
			ChatFrameEditBox:SetFocus()
		end
		getglobal(this:GetName().."EditBox"):SetText("")
	end,
	EditBoxOnEnterPressed = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox")
		BlinkCallMeNames[BlinkCallMe_Edit_number] = editBox:GetText()
		this:GetParent():Hide()

		BlinkCallMe_BuildPatterns()
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide()
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1
}

-- WhoSaid
function BCM_BM_AddWhoSaidClick()
	StaticPopup_Show("ADD_WHOSAID")
end

function BCM_BM_TWRemoveClick(number)
	if (number) then
		number = 0 + number
		BlinkWhoSaid_RemoveText(number)
	end
end

function BCM_BM_TWRemoveName(number)
	if( BlinkWhoSaidNames[number]) then
		return number..". "..BlinkWhoSaidNames[number]
	end
end

function BCM_BM_TWRemoveShow(number)
	if (BlinkWhoSaidNames[number]) then
		return true
	else
		return false
	end
end

function BCM_BM_TWRemove1Click() BCM_BM_TWRemoveClick(1) end
function BCM_BM_TWRemove1Name() return BCM_BM_TWRemoveName(1) end
function BCM_BM_TWRemove1Show() return BCM_BM_TWRemoveShow(1) end

function BCM_BM_TWRemove2Click() BCM_BM_TWRemoveClick(2) end
function BCM_BM_TWRemove2Name() return BCM_BM_TWRemoveName(2) end
function BCM_BM_TWRemove2Show() return BCM_BM_TWRemoveShow(2) end

function BCM_BM_TWRemove3Click() BCM_BM_TWRemoveClick(3) end
function BCM_BM_TWRemove3Name() return BCM_BM_TWRemoveName(3) end
function BCM_BM_TWRemove3Show() return BCM_BM_TWRemoveShow(3) end

function BCM_BM_TWRemove4Click() BCM_BM_TWRemoveClick(4) end
function BCM_BM_TWRemove4Name() return BCM_BM_TWRemoveName(4) end
function BCM_BM_TWRemove4Show() return BCM_BM_TWRemoveShow(4) end

function BCM_BM_TWRemove5Click() BCM_BM_TWRemoveClick(5) end
function BCM_BM_TWRemove5Name() return BCM_BM_TWRemoveName(5) end
function BCM_BM_TWRemove5Show() return BCM_BM_TWRemoveShow(5) end

function BCM_BM_TWRemove6Click() BCM_BM_TWRemoveClick(6) end
function BCM_BM_TWRemove6Name() return BCM_BM_TWRemoveName(6) end
function BCM_BM_TWRemove6Show() return BCM_BM_TWRemoveShow(6) end

function BCM_BM_TWRemove7Click() BCM_BM_TWRemoveClick(7) end
function BCM_BM_TWRemove7Name() return BCM_BM_TWRemoveName(7) end
function BCM_BM_TWRemove7Show() return BCM_BM_TWRemoveShow(7) end

function BCM_BM_TWRemove8Click() BCM_BM_TWRemoveClick(8) end
function BCM_BM_TWRemove8Name() return BCM_BM_TWRemoveName(8) end
function BCM_BM_TWRemove8Show() return BCM_BM_TWRemoveShow(8) end

function BCM_BM_TWRemove9Click() BCM_BM_TWRemoveClick(9) end
function BCM_BM_TWRemove9Name() return BCM_BM_TWRemoveName(9) end
function BCM_BM_TWRemove9Show() return BCM_BM_TWRemoveShow(9) end

function BCM_BM_TWRemove10Click() BCM_BM_TWRemoveClick(10) end
function BCM_BM_TWRemove10Name() return BCM_BM_TWRemoveName(10) end
function BCM_BM_TWRemove10Show() return BCM_BM_TWRemoveShow(10) end

function BCM_BM_TWRemove11Click() BCM_BM_TWRemoveClick(11) end
function BCM_BM_TWRemove11Name() return BCM_BM_TWRemoveName(11) end
function BCM_BM_TWRemove11Show() return BCM_BM_TWRemoveShow(11) end

function BCM_BM_TWRemove12Click() BCM_BM_TWRemoveClick(12) end
function BCM_BM_TWRemove12Name() return BCM_BM_TWRemoveName(12) end
function BCM_BM_TWRemove12Show() return BCM_BM_TWRemoveShow(12) end

function BCM_BM_TWRemove13Click() BCM_BM_TWRemoveClick(13) end
function BCM_BM_TWRemove13Name() return BCM_BM_TWRemoveName(13) end
function BCM_BM_TWRemove13Show() return BCM_BM_TWRemoveShow(13) end

function BCM_BM_TWRemove14Click() BCM_BM_TWRemoveClick(14) end
function BCM_BM_TWRemove14Name() return BCM_BM_TWRemoveName(14) end
function BCM_BM_TWRemove14Show() return BCM_BM_TWRemoveShow(14) end

function BCM_BM_TWRemove15Click() BCM_BM_TWRemoveClick(15) end
function BCM_BM_TWRemove15Name() return BCM_BM_TWRemoveName(15) end
function BCM_BM_TWRemove15Show() return BCM_BM_TWRemoveShow(15) end

StaticPopupDialogs["ADD_WHOSAID"] = {
	text = "채팅창에 강조할 유저이름을 입력해주십시오.\n채팅창에 지정한 유저가 말을하면 '띵~'소리와 함께 화면중앙에 표시합니다.",
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	maxLetters = 12,
	OnAccept = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox")
		BlinkWhoSaid_AddText(editBox:GetText())
	end,
	OnShow = function()
		getglobal(this:GetName().."EditBox"):SetFocus()
	end,
	OnHide = function()
		if (ChatFrameEditBox:IsVisible()) then
			ChatFrameEditBox:SetFocus()
		end
		getglobal(this:GetName().."EditBox"):SetText("")
	end,
	EditBoxOnEnterPressed = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox")
		BlinkWhoSaid_AddText(editBox:GetText())
		this:GetParent():Hide()
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide()
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1
}

-- XChannel
function BCM_BM_AddXChannelClick()
	StaticPopup_Show("ADD_XCHANNEL")
end

function BCM_BM_XCRemoveClick(number)
	if (number) then
		number = 0 + number
		BlinkXChannel_RemoveByIndex(number)
	end
end

function BCM_BM_XCRemoveName(number)
	local name = BlinkXChannelNames[number]
	if( name) then
		if( type(name) == "string") then
			return number..". "..name
		else
			local _, channel = GetChannelName(name)
			return number..". "..name.." ("..(channel or "없음")..")"
		end
	end
end

function BCM_BM_XCRemoveShow(number)
	if (BlinkXChannelNames[number]) then
		return true
	else
		return false
	end
end

function BCM_BM_XCRemove1Click() BCM_BM_XCRemoveClick(1) end
function BCM_BM_XCRemove1Name() return BCM_BM_XCRemoveName(1) end
function BCM_BM_XCRemove1Show() return BCM_BM_XCRemoveShow(1) end

function BCM_BM_XCRemove2Click() BCM_BM_XCRemoveClick(2) end
function BCM_BM_XCRemove2Name() return BCM_BM_XCRemoveName(2) end
function BCM_BM_XCRemove2Show() return BCM_BM_XCRemoveShow(2) end

function BCM_BM_XCRemove3Click() BCM_BM_XCRemoveClick(3) end
function BCM_BM_XCRemove3Name() return BCM_BM_XCRemoveName(3) end
function BCM_BM_XCRemove3Show() return BCM_BM_XCRemoveShow(3) end

function BCM_BM_XCRemove4Click() BCM_BM_XCRemoveClick(4) end
function BCM_BM_XCRemove4Name() return BCM_BM_XCRemoveName(4) end
function BCM_BM_XCRemove4Show() return BCM_BM_XCRemoveShow(4) end

function BCM_BM_XCRemove5Click() BCM_BM_XCRemoveClick(5) end
function BCM_BM_XCRemove5Name() return BCM_BM_XCRemoveName(5) end
function BCM_BM_XCRemove5Show() return BCM_BM_XCRemoveShow(5) end

function BCM_BM_XCRemove6Click() BCM_BM_XCRemoveClick(6) end
function BCM_BM_XCRemove6Name() return BCM_BM_XCRemoveName(6) end
function BCM_BM_XCRemove6Show() return BCM_BM_XCRemoveShow(6) end

function BCM_BM_XCRemove7Click() BCM_BM_XCRemoveClick(7) end
function BCM_BM_XCRemove7Name() return BCM_BM_XCRemoveName(7) end
function BCM_BM_XCRemove7Show() return BCM_BM_XCRemoveShow(7) end

function BCM_BM_XCRemove8Click() BCM_BM_XCRemoveClick(8) end
function BCM_BM_XCRemove8Name() return BCM_BM_XCRemoveName(8) end
function BCM_BM_XCRemove8Show() return BCM_BM_XCRemoveShow(8) end

function BCM_BM_XCRemove9Click() BCM_BM_XCRemoveClick(9) end
function BCM_BM_XCRemove9Name() return BCM_BM_XCRemoveName(9) end
function BCM_BM_XCRemove9Show() return BCM_BM_XCRemoveShow(9) end

function BCM_BM_XCRemove10Click() BCM_BM_XCRemoveClick(10) end
function BCM_BM_XCRemove10Name() return BCM_BM_XCRemoveName(10) end
function BCM_BM_XCRemove10Show() return BCM_BM_XCRemoveShow(10) end

function BCM_BM_XCRemove11Click() BCM_BM_XCRemoveClick(11) end
function BCM_BM_XCRemove11Name() return BCM_BM_XCRemoveName(11) end
function BCM_BM_XCRemove11Show() return BCM_BM_XCRemoveShow(11) end

function BCM_BM_XCRemove12Click() BCM_BM_XCRemoveClick(12) end
function BCM_BM_XCRemove12Name() return BCM_BM_XCRemoveName(12) end
function BCM_BM_XCRemove12Show() return BCM_BM_XCRemoveShow(12) end

function BCM_BM_XCRemove13Click() BCM_BM_XCRemoveClick(13) end
function BCM_BM_XCRemove13Name() return BCM_BM_XCRemoveName(13) end
function BCM_BM_XCRemove13Show() return BCM_BM_XCRemoveShow(13) end

function BCM_BM_XCRemove14Click() BCM_BM_XCRemoveClick(14) end
function BCM_BM_XCRemove14Name() return BCM_BM_XCRemoveName(14) end
function BCM_BM_XCRemove14Show() return BCM_BM_XCRemoveShow(14) end

function BCM_BM_XCRemove15Click() BCM_BM_XCRemoveClick(15) end
function BCM_BM_XCRemove15Name() return BCM_BM_XCRemoveName(15) end
function BCM_BM_XCRemove15Show() return BCM_BM_XCRemoveShow(15) end

StaticPopupDialogs["ADD_XCHANNEL"] = {
	text = "제외할 채널 이름또는 번호를 입력해주십시오.\n지정한 채널은 나를불러주세요 또는 누가말하나?에서 제외됩니다.",
	button1 = TEXT(ACCEPT),
	button2 = TEXT(CANCEL),
	hasEditBox = 1,
	maxLetters = 12,
	OnAccept = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox")
		BlinkXChannel_AddText(editBox:GetText())
	end,
	OnShow = function()
		getglobal(this:GetName().."EditBox"):SetFocus()
	end,
	OnHide = function()
		if (ChatFrameEditBox:IsVisible()) then
			ChatFrameEditBox:SetFocus()
		end
		getglobal(this:GetName().."EditBox"):SetText("")
	end,
	EditBoxOnEnterPressed = function()
		local editBox = getglobal(this:GetParent():GetName().."EditBox")
		BlinkXChannel_AddText(editBox:GetText())
		this:GetParent():Hide()
	end,
	EditBoxOnEscapePressed = function()
		this:GetParent():Hide()
	end,
	timeout = 0,
	exclusive = 1,
	whileDead = 1
}
