--[[
strings.lua

Strings for ChatLink.  Makes for easy editing and localization.
]]--

-- ENGLISH LANGUAGE STRINGS.
-- Function strings.
STR_CHATLINK_LOADED = "ChatLink %s loaded."
STR_CHATLINK_LOADED_WARNING = "ChatLink %s loaded, but other chat addons were detected.  Conflicts may occur."

-- System channel names.
STR_GENERAL = "General -"
STR_TRADE = "Trade -"
STR_LFG = "LookingForGroup -"
STR_LOCALDEF = "LocalDefense -"
STR_WORLDDEF = "WorldDefense"
STR_GUILDREC = "GuildRecruitment - "


-- GERMAN LANGUAGE STRINGS.
if (GetLocale() == "deDE") then
	-- Function strings.
	STR_CHATLINK_LOADED = "ChatLink %s geladen."
--	STR_CHATLINK_LOADED_WARNING = "Not translated."

	-- System channel names.
	STR_GENERAL = "Allgemein -"
	STR_TRADE = "Handel -"
	STR_LFG = "SucheNachGruppe -"
	STR_LOCALDEF = "LokaleVerteidigung -"
	STR_WORLDDEF = "WeltVerteidigung"
	STR_GUILDREC = "Gildenrekrutierung - "
end


-- FRENCH LANGUAGE STRINGS.
if (GetLocale() == "frFR") then
	-- Function strings.
	STR_CHATLINK_LOADED = "ChatLink %s charg\195\169."
--	STR_CHATLINK_LOADED_WARNING = "Not translated."

	-- System channel names.
	STR_GENERAL = "G\195\169n\195\169ral -"
	STR_TRADE = "Commerce -"
	STR_LFG = "RechercheGroupe -"
	STR_LOCALDEF = "D\195\169fenseLocale -"
	STR_WORLDDEF = "D\195\169fenseUniverselle"
	STR_GUILDREC = "RecrutementDeGuilde - "
end
