local ADDON_INFO = {
name = "JoJoAggro",
ver = "1.0",
usage = nil,
};
---------------------------------------------------------------
local function UpdateRank(rankIndicator)
	local Aggro_Value = {};
	local unit, threatvalue;
	if GetNumRaidMembers() > 0 then
		for i=1,GetNumRaidMembers() do
			for j=1,2 do
				unit = (j==1) and "raid"..i or "raidpet"..i;
				if UnitExists(unit) then
					if UnitIsUnit(unit, "player") then unit = "player" end
					threatvalue = select(5, UnitDetailedThreatSituation(unit, "target"));
					if threatvalue then tinsert(Aggro_Value, {unit, threatvalue}) end
				end
			end
		end
	else
		threatvalue = select(5, UnitDetailedThreatSituation("player", "target"));
		if threatvalue then tinsert(Aggro_Value, {"player", threatvalue}) end
		if UnitExists("pet") then
			threatvalue = select(5, UnitDetailedThreatSituation("pet", "target"));
			if threatvalue then tinsert(Aggro_Value, {"pet", threatvalue}) end
		end
		for i=1,GetNumPartyMembers() do
			for j=1,2 do
				unit = (j==1) and "party"..i or "partypet"..i;
				if UnitExists(unit) then
					threatvalue = select(5, UnitDetailedThreatSituation(unit, "target"));
					if threatvalue then tinsert(Aggro_Value, {unit, threatvalue}) end
				end
			end
		end
	end
	
	sort(Aggro_Value, function(a,b) return a[2]>b[2] end);
	
	foreachi(Aggro_Value, function(i,v) 
		if v[1] == "player" then 
			rankIndicator.text:SetText(i);
			rankIndicator:Show();
		end
	end)

	--[[for i,v in ipairs(Aggro_Value) do
		if v[1] == "player" then
			rankIndicator.text:SetText(i);
			rankIndicator:Show();
			break
		end
	end]]
	
end

local function UpdateThreatIndicator(numericIndicator, rankIndicator)
	if UnitThreatSituation("player", "target") == 0 then
		-- isTanking, status, threatpct, rawthreatpct, threatvalue
		local threatpct = select(3, UnitDetailedThreatSituation("player", "target"));
		if threatpct then
			numericIndicator.text:SetText(format("%d", threatpct).."%");
			numericIndicator.bg:SetVertexColor(GetThreatStatusColor(status));
			numericIndicator:Show();
			UpdateRank(rankIndicator);
		else
			numericIndicator:Hide();
			rankIndicator:Hide();
		end
	else
		numericIndicator:Hide();
		UpdateRank(rankIndicator);
	end
end
-----------------------------------------------------------------------
local EVENTS = {
	"UNIT_THREAT_LIST_UPDATE",
	"PLAYER_TARGET_CHANGED"
};
local function Addon_Loaded()
	JoJo:Login(ADDON_INFO , 1);
	JoJo:RegEvents(EVENTS, this);
	this:UnregisterEvent("ADDON_LOADED");
end
----------------------------------------------------------------------
function JoJoAggro_OnLoad()
	this.title = ADDON_INFO.name;
	this.version = ADDON_INFO.ver;
	
	this:RegisterEvent("ADDON_LOADED");

	Addon_Loaded();
	JoJoAggro_OnLoad = nil;
end

function JoJoAggro_OnEvent(event)
	if event == "ADDON_LOADED" then
		if (arg1 == ADDON_INFO.name) then Addon_Loaded() end
		return
	end
	if (event == "UNIT_THREAT_LIST_UPDATE" and arg1=="target") or event == "PLAYER_TARGET_CHANGED" then
		local numericIndicator = JoJoAggroNumericalThreat;
		local rankIndicator = JoJoAggroRank;
		if IsThreatWarningEnabled() and ShowNumericThreat() then
			UpdateThreatIndicator(numericIndicator, rankIndicator);
		else
			numericIndicator:Hide();
			rankIndicator:Hide();
		end
	end
end
