JoJo = JoJo or {};
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
SLASH_JOJO1 = "/jojo";
SLASH_JOJO2 = "/JOJO";
SLASH_JOJO3 = "/죠죠";

SlashCmdList["JOJO"] = function()
	if JoJo.addons then
		JoJo:Notice("♥♥ 죠죠의 기묘한 모험 ♥♥");
		for i,v in pairs(JoJo.addons) do
			local usage = "";
			if v[1] and v[1]~="" then
				usage = usage .. v[1];
			end
			usage = v[2] and usage .. " or " .. v[2] or usage;
			usage = (usage=="") and UNKNOWN or "("..usage..")";
			JoJo:Notice(i.." : "..usage);
		end
	end
end
---------------------------------------------------------------------------------------
function JoJo:Login(info, print)
	JoJo.addons = JoJo.addons or {};
	JoJo.addons[info.name] = {};
	for i=1,2 do
		if info.usage and info.usage[i] then
			JoJo.addons[info.name][i] = info.usage[i];
		end
	end
	if print then
		local msg;
		if info.usage then
			local usage = info.usage[1];
			usage = info.usage[2] and usage .. " or " .. info.usage[2] or usage;
			msg = format("%s ver.%s Loaded. (usage:%s)" , info.name , info.ver , usage);
		else
			msg = format("%s ver.%s Loaded." , info.name , info.ver);
		end
		JoJo:Notice(msg);
	end
end

function JoJo:Print(msg, r, g, b, frame)
	r , g , b = r or 1.0 , g or 1.0 , b or 1.0;
	frame = frame or DEFAULT_CHAT_FRAME or error("There is no DEFAULT_CHAT_FRAME.");
	frame:AddMessage(msg , r , g , b);
end

function JoJo:Notice(msg)
	JoJo:Print(msg, 1,0.7,0.2);
end

function JoJo:Error(msg)
	JoJo:Print(msg, 1, 0.1, 0.1, UIErrorsFrame);
end

function JoJo:RegEvents(events, frame, unreg )
	frame = frame or this;
	if not unreg then
		for i,v in ipairs(events) do
			frame:RegisterEvent(v)
		end
	else
		for i,v in ipairs(events) do
			frame:UnregisterEvent(v)
		end
	end
end

function JoJo:HookFunc(HookFunc , myFunc , mode)
	mode = mode or "post";
	local oldFunc = getglobal(HookFunc);
	local newFunc;
	if strsub(mode , 1 , 4) == "post" then
		newFunc = function(...)
			local return0 = { oldFunc(...) };
			local return1 = { myFunc(...) };
			local returns = strfind(mode , '1') and return1 or return0
			return unpack( returns );
		end
	elseif mode == "pre" then
		newFunc = function(...)
			local returns = { myFunc(...) };
			if #returns > 0 then
				return unpack( returns );
			end
			returns = { oldFunc(...) };
			return unpack( returns );
		end
	elseif strsub(mode , 1 , 7) == "cascade" then
		newFunc = function(...)
			local return0 = { oldFunc(...) };
			local return1 = { myFunc(unpack( return0 )) };
			local returns = strfind(mode , '1') and return1 or return0
			return unpack( returns );
		end
	end
	setglobal(HookFunc, newFunc);
end

function JoJo:AddScript(frame , script , myFunc)
	local oldfunc = frame:GetScript(script) or function() --[[nothing]] end;
	local function new_func(...)
		oldfunc(...);
		myFunc(...);
	end
	frame:SetScript(script , new_func);
end

function JoJo:Toggle(frame , state)
	if frame:IsVisible() then
		if not state or state == 0 then
			frame:Hide();
			state = 0;
		end
	else
		if not state or state == 1 then
			frame:Show();
			state = 1;
		end
	end
	return state;
end

function JoJo:GetSize(frame)
	return frame:GetWidth() , frame:GetHeight()
end

function JoJo:SetSize(width , height , frame)
	if height and type(height)~="number" then
		frame = height;
		height = width;
	end
	frame = frame or this;
	height = height or width;
	frame:SetWidth(width);
	frame:SetHeight(height);
end

function JoJo:Tooltip_ClearLines(tooltip)
	for i=1,(tooltip:NumLines()) do
		getglobal(tooltip:GetName().."TextRight"..i):SetText();
	end
	tooltip:ClearLines(); -- erase left only
	tooltip:SetOwner(UIParent, "ANCHOR_NONE");
end


-------------------------------------------------------------------------------------
