T_CooldownScale = 1
T_CooldownWidth = 150
T_CooldownHeight = 20
T_CooldownIcon = 16

T_CooldownWaitLimited = {
	default = 6,
	["죽은척하기"] = 330,
}

T_CooldownShowLimited = 1200

-- T_CooldownScale : 배율
-- T_CooldownWidth : 넓이
-- T_CooldownHeight : 높이
-- T_CooldownIcon : 아이콘 크기
-- T_CooldownWaitLimited : 쿨다운을 처리하기 위한 최대 대기시간 처리용 ["주문명"] = 초,
-- T_CooldownShowLimited : 이 시간을 넘어가는 쿨타임을 가진 아이템은 시간안에 들어와야 표시(초)

--local SetCooldownBar, SetCooldownType, OnUpdate, OnEvent


local activebrod = {}
local activespells = {}

local drag = CreateFrame("Frame", "T_CooldownBarAnchor", UIParent)
drag:SetPoint("center")
drag:SetWidth(T_CooldownWidth)
drag:SetHeight(T_CooldownHeight)
drag:SetScale(T_CooldownScale)
drag.t = drag:CreateTexture()
drag.t:SetAllPoints(drag)


local brodframe = CreateFrame("frame", nil, UIParent)
brodframe.text = brodframe:CreateFontString(nil, "OVERLAY","ChatFontNormal")
brodframe.text:SetFont("Fonts\\K_damage.ttf",19,"OUTLINE")
brodframe.icon2 = brodframe:CreateTexture(nil, "OVERLAY")
brodframe.icon = brodframe:CreateTexture(nil, "ARTWORK")
brodframe.icon2:SetTexture("Interface\\AddOns\\T_Cooldown\\bg")
brodframe:SetWidth(50)
brodframe:SetHeight(50)
brodframe.icon:SetAllPoints(brodframe)
brodframe.icon2:SetPoint("center",brodframe,"center",0,0)
brodframe.icon2:SetWidth(82)
brodframe.icon2:SetHeight(82)
brodframe.text:SetPoint("top", brodframe, "bottom", 0, -5)
brodframe:Hide()
brodframe:SetScript("OnUpdate", function(self)
	if not self.time then
		self:Hide()
		return
	end
	local scale = GetTime() - self.time
	if scale > 1 then
		if scale > 1.5 then
			self.time = nil
			self:SetScale(1)
			self:SetAlpha(1)
			if self.spell then
				activebrod[self.spell] = nil
				self.spell = nil
			end
			self:Hide()
		end
	else
		local point = self.type == "active" and -150 or 150
		self:SetPoint("center", 0, 0)
--		self:SetAlpha(scale > 0.8 and 0.8 or scale)
		self.icon2:SetVertexColor(1, 1, 1, 1.0-scale*1.5)
--		self:SetScale(1+(scale/0.5))
		return
	end
end)

local icons = {}
local main = CreateFrame("frame", nil, drag)
main:SetAllPoints(drag)

		local bg2= main:CreateTexture(nil,"ARTWORK")
		bg2:SetPoint("center",main,"center",0,0)
		bg2:SetTexture("Interface\\AddOns\\T_Cooldown\\bottom")
		bg2:SetVertexColor(1,1,1,0.7)
		bg2:SetWidth(T_CooldownWidth)
		bg2:SetHeight(T_CooldownHeight)

--[[ 간단 체력 표시용 
do
	main:SetBackdrop({
			bgFile = "Interface\\ChatFrame\\ChatFrameBackground", tile = true, tileSize = 16,
			--edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 10,
			--insets = {left = 2, right = 2, top = 2, bottom = 2},
			insets = {left = 0, right = 0, top = 0, bottom = 0},
	})
	main:SetBackdropColor(0, 0, 0, 0.7)


	local player = CreateFrame("statusbar", nil, main)
	player:SetPoint("topleft")
	player:SetPoint("bottomright", main, "topright", 0, -2.5)
	player:SetStatusBarTexture("Interface\\AddOns\\T_Cooldown\\smoothbar")
	player:SetStatusBarColor(0, 0.5, 1)
	local target = CreateFrame("statusbar", nil, main)
	target:SetPoint("bottomleft")
	target:SetPoint("topright", main, "bottomright", 0, 2.5)
	target:SetStatusBarTexture("Interface\\AddOns\\T_Cooldown\\smoothbar")
	target:SetStatusBarColor(1, 0.5, 0)
	main:RegisterEvent("PLAYER_TARGET_CHANGED")
	main:RegisterEvent("UNIT_HEALTH")
	main:SetScript("OnEvent", function(self, event, unit)
		if not self:IsShown() then
			return
		end
		if event == "PLAYER_TARGET_CHANGED" then
			self.unit = UnitExists("target") and UnitCanAttack("player", "target") and not UnitIsDead("target")
		end
		player:SetMinMaxValues(0, UnitHealthMax("player"))
		player:SetValue(UnitHealth("player"))
		if not self.unit then
			target:SetMinMaxValues(0, 1)
			target:SetValue(1)
		elseif self.unit then
			target:SetMinMaxValues(0, UnitHealthMax("target"))
			target:SetValue(UnitHealth("target"))
		end
	end)
end
--]]
local function OnEnter(self)
	local t = _G["Get"..self.type.."Info"](self.id)
	if t then
		GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT")
		if self.type == "PetAction" then
			GameTooltip:AddDoubleLine(t.."|CFFFFFF00(펫)",string.format(SecondsToTimeAbbrev(self.timeLeft)), 0, 0.5, 1, 1, 1, 0)
		else
			GameTooltip:AddDoubleLine(t,string.format(SecondsToTimeAbbrev(self.timeLeft)), 0, 0.5, 1, 1, 1, 0)
		end
		GameTooltip:Show()
	end
	
end
local function OnLeave(self)
	GameTooltip:Hide()
end

local function createicon(index, type, id)
	if not icons[index] then
		local f = CreateFrame("frame", nil, main)
		f:SetWidth(T_CooldownIcon)
		f:SetHeight(T_CooldownIcon)
		f:EnableMouse(true)
		f:SetScript("OnEnter", OnEnter)
		f:SetScript("OnLeave", OnLeave)
		local bg = f:CreateTexture(nil,"OVERLAY")
		bg:SetPoint("center",f,"center",0,0)
		bg:SetTexture("Interface\\AddOns\\T_Cooldown\\Normal")
		bg:SetVertexColor(0.5,0.5,0.5)
		bg:SetWidth(T_CooldownIcon*1.8)
		bg:SetHeight(T_CooldownIcon*1.8)
		local ftext = f:CreateFontString(nil, "OVERLAY","ChatFontNormal")
		ftext:SetFont("Fonts\\K_damage.ttf",T_CooldownIcon-6,"OUTLINE")
		ftext:SetPoint("bottom",f,"top",3,0)
		f.text = ftext
		local t = f:CreateTexture(nil, "OVERLAY")
		t:SetTexCoord(0.09,0.9,0.06,0.93)
		t:SetAllPoints(f)
		f.icon = t
		icons[index] = f
	end
	if icons[index].id ~= id then
		icons[index].type = type
		icons[index].id = id
	end
	icons[index]:Show()
	return icons[index]
end

local function SetCooldownBar(type, index)
	local t = GetTime()
	for k, v in pairs(T_CooldownSave[type]) do
		local start, duration = strsplit(":", v)
		duration = tonumber(duration)
		if not duration then
			if t - v > (T_CooldownWaitLimited[k] or T_CooldownWaitLimited.default) then -- 11초뒤 쿨타임이 없으면 테이블에서 삭제(귀환석처럼 캐스팅이 긴것들 처리용)
				T_CooldownSave[type][k] = nil
			end
		else
			local timeLeft = start+duration - t
			if start+duration <= t then
				for i, j in pairs(T_CooldownSave.timeTable) do
					if j == k then
						T_CooldownSave.timeTable[i] = nil
					end
				end
				if duration > 3 and brodframe then
					if type == "Item" then
						brodframe.icon:SetTexture(GetItemIcon(k))
					else
						brodframe.icon:SetTexture(select(3, _G["Get"..type.."Info"](k)))
					end
					if type == "PetAction" then
						local t = _G["Get"..type.."Info"](k)
						if t then
							brodframe.text:SetText("|CFF0080FF"..t.."|CFFFFFF00(펫)")
						end
					else
						brodframe.text:SetText("|CFFFFFFFF".._G["Get"..type.."Info"](k).."|CFFFFFFFF 준비!")
					end
					brodframe.time = t
					brodframe.type = "ready"
					brodframe:Show()
				end
				T_CooldownSave[type][k] = nil
			elseif timeLeft <= T_CooldownShowLimited then
				local f = createicon(index, type, k)
				f.timeLeft = timeLeft
				if GetMouseFocus() == f then OnEnter(f) end
				local w = main:GetWidth()
				local p = w*(timeLeft/(duration > T_CooldownShowLimited and duration - T_CooldownShowLimited or duration))
				local iw = f:GetWidth()
				f:SetPoint("center", main, "right", -p - iw > w  and -w + iw or -p , 0)
				f.text:SetText(string.format(SecondsToTimeAbbrev(f.timeLeft)))
				if type == "Item" then
					f.icon:SetTexture(GetItemIcon(k))
				else
					f.icon:SetTexture(select(3, _G["Get"..type.."Info"](k)))
				end
				if not main:IsShown() then
					main:Show()
				end
				index = index + 1
			end
		end
	end
	return index
end
local function SetCooldownType(ctype)
	for id, value in pairs(T_CooldownSave[ctype]) do
		local start, duration, enabled = _G["Get"..ctype.."Cooldown"](id)
		if type(value) == "number" then
			if start and start > 0 and (duration > 2 and duration < 86400) and enabled > 0 then
				local t = start..":"..duration
				if T_CooldownSave.timeTable[t] then
					T_CooldownSave[ctype][id] = nil
				else
					T_CooldownSave.timeTable[t] = id
					T_CooldownSave[ctype][id] = t
				end
			elseif not start then
				T_CooldownSave[ctype][id] = nil
			end
		elseif duration then
			local s, d = strsplit(":", value)
			if d and tonumber(s) ~= start then
				if duration > 86400 then
					T_CooldownSave[ctype][id] = nil
					T_CooldownSave.timeTable[value] = nil
				else
					T_CooldownSave[ctype][id] = start..":"..duration
					T_CooldownSave.timeTable[start..":"..duration] = id
				end
			end
		end
	end
end
local function SetActiveSpell(index)
	local t = GetTime()
	for spell, start in pairs(activespells) do
		local duration = T_Cooldown_Active[spell]
		local timeLeft = start + duration - t
		if timeLeft <= 0 then
			activespells[spell] = nil
		else
			local f = createicon(index, "Spell", spell)
			local w = main:GetWidth()
			local iw = f:GetWidth()
			local p = w - w * (timeLeft/duration) - iw
			f.timeLeft = timeLeft
			f:SetPoint("left", main, "left", p < 0 and 0 or p, 0)
			f.icon:SetTexture(select(3, GetSpellInfo(spell)))
			index = index + 1
			main:Show()
		end
	end
	return index
end
local updateCycle = 2
local function OnUpdate(self, elapsed)
	if self.nextUpdate == 0 then
		local i = SetCooldownBar("Item", SetCooldownBar("Spell", 1))
		if UnitIsVisible("playerpet") then
			i = SetCooldownBar("PetAction", i)
		end
		i = SetActiveSpell(i)

		if i == 1 then
			updateCycle = 5
			main:Hide()
		else
			updateCycle = 1
		end
		while icons[i] do
			icons[i]:Hide()
			i = i + 1
		end
	end
	self.nextUpdate = self.nextUpdate == updateCycle and 0 or self.nextUpdate + 1
end

local function OnEvent(self, e, ...)
	if e == "VARIABLES_LOADED" then
		T_CooldownSave = T_CooldownSave or {}
		T_CooldownSave.Spell = T_CooldownSave.Spell or {}
		T_CooldownSave.Item = T_CooldownSave.Item or {}
		T_CooldownSave.PetAction = T_CooldownSave.PetAction or {}
		T_CooldownSave.timeTable = T_CooldownSave.timeTable or {}
		if T_CooldownSave.ShowPet then
			drag:RegisterEvent("PET_BAR_UPDATE_COOLDOWN")
		end
	elseif e == "BAG_UPDATE_COOLDOWN" then
		SetCooldownType("Item")
	elseif e == "SPELL_UPDATE_COOLDOWN" then
		SetCooldownType("Spell")
	elseif e == "UNIT_INVENTORY_CHANGED" then
		for i = 0, 19 do
			local s, d, e = GetInventoryItemCooldown("player", i)
			if s and s > 0 and d > 2 and e > 0 then
				local t = s..":"..d
				if not T_CooldownSave.timeTable[t] then
					local item = GetInventoryItemLink("player", i)
					local id = tonumber(item:match("item:(%d+)"))
					T_CooldownSave.Item[id] = t
					T_CooldownSave.timeTable[t] = id
				end
			end
		end
	elseif e == "PET_BAR_UPDATE_COOLDOWN" then
		for i=1, NUM_PET_ACTION_SLOTS do
			local s, d, e = GetPetActionCooldown(i);
			if s and s > 0 and d > 2 and e > 0 then
				T_CooldownSave.PetAction[i] = s..":"..d
			end
		end
	elseif e == "CHAT_MSG_BG_SYSTEM_NEUTRAL" then
		local msg = ...
		if tostring(msg):match("투기장 전투 시작 .- 전입니다") then
			SetCooldownType("Spell")
			SetCooldownType("Item")
			SetCooldownType("PetAction")
		end
	else
		local unit, spellName = ...
		if not unit or not spellName then
			return
		end
		if type(spellName) == "string" and unit == "player" and GetSpellInfo(spellName) then
			T_CooldownSave.Spell[spellName] = T_CooldownSave.Spell[spellName] or GetTime()
		end
	end
end

local UseContainerItem_Hook, UseInventoryItem_Hook, UseItemByName_Hook, UseAction_Hook
function UseItemByName_Hook(item)
	if not item then
		return
	end
	local id =  tonumber(item) or tonumber(item:match("item:(%d+)"))
	if not id then
		item = select(2, GetItemInfo(item))
		id = item and tonumber(item:match("item:(%d+)"))
	end
	if id and not T_CooldownSave.Item[id] and GetItemCount(id) ~= 0 then
		T_CooldownSave.Item[id] = GetTime()
	end
end
function UseContainerItem_Hook(bag, slot)
	UseItemByName_Hook(GetContainerItemLink(bag, slot))
end
function UseInventoryItem_Hook(slot)
	UseItemByName_Hook(GetInventoryItemLink("player", slot-1))
	UseItemByName_Hook(GetInventoryItemLink("player", slot))
	UseItemByName_Hook(GetInventoryItemLink("player", slot+1))
end
function UseAction_Hook(slot)
	local item, id = GetActionInfo(slot)
	if item == "item" then
		UseItemByName_Hook(id)
	end
end

hooksecurefunc("UseContainerItem", UseContainerItem_Hook)
hooksecurefunc("UseInventoryItem", UseInventoryItem_Hook)
hooksecurefunc("UseItemByName", UseItemByName_Hook)
hooksecurefunc("UseAction", UseAction_Hook)

drag:RegisterEvent("UNIT_SPELLCAST_STOP")
drag:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
drag:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
drag:RegisterEvent("UNIT_SPELLCAST_FAILED")
drag:RegisterEvent("UNIT_SPELLCAST_FAILED_QUIET")
drag:RegisterEvent("BAG_UPDATE_COOLDOWN")
drag:RegisterEvent("SPELL_UPDATE_COOLDOWN")
drag:RegisterEvent("UNIT_INVENTORY_CHANGED")
drag:RegisterEvent("VARIABLES_LOADED")
drag:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL")

drag.nextUpdate = 0
drag:SetScript("OnEvent", OnEvent)
drag:SetScript("OnUpdate", OnUpdate)
drag:SetScript("OnDragStart", drag.StartMoving)
drag:SetScript("OnDragStop", drag.StopMovingOrSizing)

drag.txt = drag:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
drag.txt:SetText("T_Cooldown")
drag.txt:SetPoint("center")

drag.t:SetTexture(0, 1, 0, 0.7)

drag:SetClampedToScreen(true)
drag:RegisterForDrag("LeftButton")
drag:SetMovable(true)
drag:SetFrameStrata("BACKGROUND")

SLASH_TCOOLDOWN1, SLASH_TCOOLDOWN2, SlashCmdList.TCOOLDOWN = "/쿨다운", "/tc", function(msg)
	if msg and msg == "펫" then
		if T_CooldownSave.ShowPet then
			ChatFrame1:AddMessage("소환수의 쿨다운을 표시하지 않습니다", 1, 0.8, 0.2)
			T_CooldownSave.ShowPet = nil
			drag:UnregisterEvent("PET_BAR_UPDATE_COOLDOWN")
		else
			ChatFrame1:AddMessage("소환수의 쿨다운을 표시합니다", 0.2, 0.8, 1)
			T_CooldownSave.ShowPet = true
			drag:RegisterEvent("PET_BAR_UPDATE_COOLDOWN")
		end
		return
	end
	if drag.t:IsVisible() then
		drag.t:Hide()
		drag.txt:Hide()
		drag:EnableMouse(false)
	else
		drag.txt:Show()
		drag.t:Show()
		drag:EnableMouse(true)
	end
end

SlashCmdList.TCOOLDOWN()


if not T_Cooldown_Active or not next(T_Cooldown_Active) then return end
local activeframe = CreateFrame("frame")
activeframe:RegisterEvent("COMBAT_TEXT_UPDATE")
activeframe:SetScript("OnEvent", function(self, event, ...)
	local text, spell = ...
	if text == "SPELL_ACTIVE" and T_Cooldown_Active[spell] then
		if IsUsableSpell(spell) then
			if not activebrod[spell] then
				if T_Cooldown_Active[spell] > 0 then
					activebrod[spell] = true
					activespells[spell] = GetTime()
				end
				brodframe.icon:SetTexture(select(3, GetSpellInfo(spell)))
				brodframe.time = GetTime()
				brodframe.text:SetText("|CFF0080FF"..spell.."|CFFFFFF00(활성)")
				brodframe.type = "active"
				brodframe.spell = spell
				brodframe:Show()
				activebrod[spell] = true
			end
		else
			activebrod[spell] = nil
		end
	end
end)
