local inColor = { 0.2, 1, 0.2, 1 }
local outColor = { 1, 0.5, 0.3, 1 }
local meleeIn = {[10] = { 1, 0.8, 0, 1 }, warning = { 1, 0.2, 0, 1 }}

local _, class =UnitClass("player")
local caster = {WARLOCK = true, MAGE = true, PRIEST = true}

local textmin = "maxm 이내"
local textin = "minm-maxm 이내"
local textout = "maxm 이상"

local function normal(self, text)
	self.text:SetText((text or textin):gsub("min", self.minrange):gsub("max", self.maxrange))
end

local function MinRange(self)
	self.frame:Show()
	if self.targetType and self.targetType == "harm" and caster[class] and not UnitIsDead(self.unit) then
		self.text:SetTextColor(unpack(meleeIn[self.maxrange] or meleeIn.warning))
	else
		self.text:SetTextColor(unpack(inColor))
	end
	if self.minrange == 0 then
		normal(self, textmin)
	else
		normal(self)
	end
end
local function MaxRange(self)
	if not self.minrange then
		--self.text:SetTextColor(unpack(outColor))
		--normal(self, textout)
		self.frame:Hide()
	else
		self.frame:Show()
		self.text:SetTextColor(unpack(inColor))
		normal(self)
	end
end
local function new(frame)
	frame.frame = CreateFrame("frame", "T_RangeFrame"..frame.unit, frame)
	frame.frame:SetClampedToScreen(true)

	frame.frame:SetPoint("center")
	frame.frame:SetWidth(100)
	frame.frame:SetHeight(15)

	frame.frame:EnableMouse(true)
	frame.frame:SetMovable(true)
	frame.frame:RegisterForDrag("LeftButton")
	frame.frame:SetScript("OnDragStart", function(self) if IsShiftKeyDown() then self:StartMoving() end end)
	frame.frame:SetScript("OnDragStop", frame.frame.StopMovingOrSizing)

	frame.text = frame.frame:CreateFontString(nil, "OVERLAY")
	frame.text:SetFont("Fonts\\2002.TTF", frame.unit == "target" and 20 or 14)
	frame.text:SetTextColor(1, 0.7, 0)
	frame.text:SetShadowOffset(1, -1)
	frame.text:SetPoint("CENTER", 0, 1)
end

new(T_Range("target", MinRange, MaxRange))
new(T_Range("focus", MinRange, MaxRange))