if GetLocale() == "koKR" then
	return
end

-- 영어로 바꿔쓰세요...ㅡ_ㅡ;;

--[[
	T_RangeSpell = {"주문1", "주문2"} -- 거리를 체크할 주문
	T_RangeSpellCompare = {["주문명"] = 비교함수,} -- 특정한 대상에게만 적용되는 주문들일경우
]]


local class, engclass = UnitClass("player")

local function _UCT(self, type) return UnitCreatureType(self.unit) == type end
local function _UIU(self, unit) return UnitIsUnit(self.unit, unit) end
local function _UIR(self) local id = UnitInRaid(self.unit) return id and _UIU(self, "raid"..id) end

local function _UCT_Human(self) return _UCT(self, "인간형") end -- 인간형만 적용될경우
local function _UCT_Demon(self) return _UCT(self, "악마") end -- 악마만 적용될경우
local function _UCT_Undead(self) return _UCT(self, "언데드") end -- 언데드만 적용될경우
local function _UCT_Beast(self) return _UCT(self, "야수") end -- 야수만 적용될경우
local function _UCT_Dragon(self) return _UCT(self, "용족") end -- 용족에게만 적용될경우
local function _UCT_BeastOrDragon(self) return _UCT_Beast(self) or _UCT_Dragon(self) end -- 용족 또는 야수만 적용될경우
local function _UCT_DemonOrUndead(self) return _UCT_Demon(self) or _UCT_Undead(self) end -- 악마 또는 언데드만 적용될경우

local function _UIP(self) return UnitInParty(self.unit) or _UIR(self) end -- 파티/공격대에게만 적용될경우
local function _UIU_Pet(self) return _UIU(self, "pet") end -- 펫한테만 적용될경우

--[[
UnitCreatureType = 대상의 종류
UnitInParty = 대상이 파티인지 확인
UnitInRaid = 대상이 공격대원인지 확인
UnitIsUnit = 대상이 특정대상(파티원인가?펫인가?공격대인가?주시대상인가?주시대상의대상인가등) 확인
]]

local all = { "나루의 선물" }
T_RangeSpell = {}
T_RangeSpellCompare = {}

if engclass == "MAGE" then

	T_RangeSpell = {  "신비한 지능", "화염 작렬", "얼음 화살", "화염구", }
	T_RangeSpellCompare = {}

elseif engclass == "WARLOCK" then

	T_RangeSpell = { "어둠의 화살", "부패", "생명력 집중", "영원의 숨결", "공포"}
	T_RangeSpellCompare = {["생명력 집중"] = _UIU_Pet,}

elseif engclass == "SHAMAN" then
	-- 폭격(근접), 대충20, 번화30, 하치물40
	T_RangeSpell = {"대지 충격", "번개 화살", "고대의 영혼", "치유의 물결" }
	T_RangeSpellCompare = {}
	T_RangeMelee = "폭풍의 일격"

elseif engclass == "WARRIOR" then
	-- 돌진(8~25) 가로막기(8~25) 발사(5~30)
	T_RangeSpell = { "돌진", "가로막기", "발사" }
	T_RangeSpellCompare = {["가로막기"] = _UIP,}

elseif engclass == "PALADIN" then
	-- 심판10, 신충20, 참회20, 천망30, 힘축30, 빛섬40
	T_RangeSpell = {"신성 충격", "참회", "천벌의 망치", "힘의 축복", "빛의 섬광", }
	T_RangeSpellCompare = {["참회"] = _UCT_Human,}
	T_RangeMelee = "성전사의 일격"

elseif engclass == "PRIEST" then
	-- 정배20, 정분30, 성격36, 평정40, 인내30, 소생40
	T_RangeSpell = { "정신 지배", "정신 분열", "성스러운 일격", "평정", "신의 권능: 인내", "소생" }
	T_RangeSpellCompare = { ["정신 지배"] = _UCT_Human,}

elseif engclass == "HUNTER" then
	T_RangeSpell = { "자동 사격", "동물 치료", "산탄 사격", "야수 길들이기"}
	T_RangeSpellCompare = {["동물 치료"] = _UIU_Pet, ["야수 길들이기"] = _UCT_Beast}

elseif engclass == "ROGUE" then
	-- 기절(근접), 실명10, 혼란30
	T_RangeSpell = { "투척", "실명", "혼란"}
	T_RangeSpellCompare = {}

elseif engclass == "DRUID" then
	-- 갈발,가르기,할퀴기(근접), 회바20, 야돌25, 천벌30, 야징30, 회복40
	--T_RangeSpell = { "할퀴기", "천벌", "야생의 징표", "회복" }
	T_RangeSpell = {"야성의 돌진", "회오리바람", "천벌", "야생의 징표", "회복" }
	T_RangeSpellCompare = {}
	T_RangeMelee =  "할퀴기"
elseif engclass == "DEATHNIGHT" then
	-- 심판10, 신충20, 어둠망령20, 죽고30, 힘축30, 빛섬40
	T_RangeSpell = {"어둠의 망령", "죽음의 고리"}
	T_RangeSpellCompare = {["시체 되살리기"] = _UCT_Human,}
	T_RangeMelee = "피의 일격"
end

for _,v in pairs(all) do
	table.insert(T_RangeSpell, v)
end
all = nil