local FadeContainer = function(self, id)
	if(self.object.noFading) then return nil end
	for _, bag in pairs(self.object.Bags) do
		if(id and bag.id ~= id) then
			bag:SetAlpha(self.object.FadeAlpha or .3)
		else
			bag:SetAlpha(1)
		end
	end
end

local BagButtonClick = function(self)
	if(not self.object:Handler("PutItemInBag", self.id)) then
		self.bag.Hidden = not self.bag.Hidden
		self.object:BAG_UPDATE(nil, nil, 1)
	end
end

local BagButtonDrag = function(self)
	PickupBagFromSlot(self.id)
end

local CreateBagButton = function(self, i)
	local button = CreateFrame("CheckButton", self.Name.."BagButton"..i, self.BagButtons, "ItemButtonTemplate")
	button:SetWidth(self.BagButtonWidth or 37)
	button:SetHeight(self.BagButtonHeight or 37)
	button.object = self
	button:RegisterForDrag("LeftButton")
	button:RegisterForClicks("anyUp")
	button:SetPoint("TOPLEFT", self.BagButtons, "TOPLEFT", (i-1) * (button:GetWidth() + (self.BagButtonSpacing or 1)), 0)
	button:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight", "ADD")
	return button
end

local EnterAndFade = function(self)
	FadeContainer(self, self.bag.id)
	self.object:Handler("BagButtonEnter", self)
end

local LeaveAndFade = function(self)
	FadeContainer(self)
	GameTooltip:Hide()
end

function cargBags:UpdateBagButtons()
	for _, bag in pairs(self.Bags) do
		if(bag.id>0) then
			local button = self.BagButtons[bag.id] or CreateBagButton(self, bag.id)

			button:SetScript("OnClick", BagButtonClick)
			button:SetScript("OnReceiveDrag", BagButtonClick)
			button:SetScript("OnEnter", EnterAndFade)
			button:SetScript("OnLeave", LeaveAndFade)
			button:SetScript("OnDragStart", BagButtonDrag)
			local textureName
			if(bag.id<=NUM_BAG_SLOTS) then
				id, textureName, _ = GetInventorySlotInfo("Bag"..(bag.id-1).."Slot")
			else
				id = BankButtonIDToInvSlotID(bag.id, 1)
				if(bag.id-NUM_BAG_SLOTS <= (self:Handler("GetNumBankSlots") or 0) ) then
					SetItemButtonTextureVertexColor(button, 1.0,1.0,1.0);
					button.tooltipText = BANK_BAG
				else
					SetItemButtonTextureVertexColor(button, 1.0,0.1,0.1);
					button.tooltipText = BANK_BAG_PURCHASE
					bag.Hidden = true
				end
			end
			button:SetID(id)
			button.link = self:Handler("GetInventoryItemLink", "player", id)
			local icon = self:Handler("GetInventoryItemTexture", "player", id)
			local texture = getglobal(button:GetName().."IconTexture")
			texture:SetTexture(icon or textureName)
			button.backgroundTextureName = textureName
			button.id = id
			button.bag = bag
			if(bag.Hidden) then
				button:SetChecked(0)
			else
				button:SetChecked(1)
			end
			self.BagButtons[bag.id] = button
		end
	end
end
cargBags.bagUpdaters["BagButtons"] = cargBags.UpdateBagButtons
